// FUNC2.CPP
// , ⨪

#define Uses_TApplication
#define Uses_TMenuBar
#define Uses_TRect
#define Uses_TSubMenu
#define Uses_TKeys
#define Uses_TMenuItem
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
#define Uses_TPoint
#define Uses_TEditor
#define Uses_MsgBox
#define Uses_TFileDialog
#define Uses_TDeskTop

#include <tv.h>

//砥 ᠭ ᮢ
#include "edit.h"

#include <stdarg.h>
#include <strstrea.h>
#include <iomanip.h>

TMenuBar *TEditorApp::initMenuBar( TRect r ) { //ᠭ 
 TSubMenu& sub1 =
  *new TSubMenu( "~a~", kbAltF ) +
  *new TMenuItem( "~~", cmNew, kbNoKey ) +
  *new TMenuItem( "~~...", cmOpen, kbF3 ) +
  *new TMenuItem( "~~࠭", cmSave, kbF2, hcNoContext, "F2" ) +
  *new TMenuItem( "~~ ...", cmSaveAs, kbNoKey ) +
  newLine() +
  *new TMenuItem( "~~", cmClose, kbAltF3, hcNoContext, "Alt-F3" ) +
  *new TMenuItem( "~~室", cmQuit, kbAltX, hcNoContext, "Alt-X" );

 TSubMenu& sub2 = *new TSubMenu( "~K~", kbAltK ) +
  *new TMenuItem( "~~⬥", cmUndo, kbNoKey ) +
  newLine() +
  *new TMenuItem( "~~...", cmFind, kbF7, hcNoContext, "F7"  ) +
  *new TMenuItem( "~~...", cmReplace, kbCtrlG, hcNoContext, "Ctrl-G" ) +
  *new TMenuItem( " ~~", cmSearchAgain, kbShiftF7, hcNoContext, "Shift-F7"  );

 TSubMenu& sub3 = *new TSubMenu( "~O~", kbAltO ) +
  *new TMenuItem( "~~/",cmResize, kbCtrlF5, hcNoContext, "Ctrl-F5" ) +
  *new TMenuItem( "~~", cmZoom, kbF5, hcNoContext, "F5" ) +
  *new TMenuItem( "~~", cmTile, kbNoKey ) +
  *new TMenuItem( "~~᪠", cmCascade, kbNoKey ) +
  *new TMenuItem( "~~饥", cmNext, kbF6, hcNoContext, "F6" ) +
  *new TMenuItem( "~~।饥", cmPrev, kbShiftF6, hcNoContext, "Shift-F6" );

 TSubMenu& sub4 = *new TSubMenu( "~m~", kbAltM ) +
  *new TMenuItem( "~~ ணࠬ", cmAbout, kbF1, hcNoContext, "F1" );

 r.b.y = r.a.y+1;
 return new TMenuBar( r, sub1 +  sub2 + sub3 + sub4);
}

TStatusLine *TEditorApp::initStatusLine( TRect r ) { //ப ﭨ
 r.a.y = r.b.y-1;
 return new TStatusLine( r, *new TStatusDef( 0, 0xFFFF ) +
  *new TStatusItem("~F2~ ࠭", kbF2, cmSave ) +
  *new TStatusItem( "~F3~ ", kbF3, cmOpen ) +
  *new TStatusItem( "~Alt-F3~ ", kbAltF3, cmClose ) +
  *new TStatusItem( "~F10~ ", kbF10, cmMenu ) +
  *new TStatusItem( 0, kbCtrlF5, cmResize )  );
}

void TEditorApp::outOfMemory() { //墠⪠ 
    messageBox("   믮 樨!", mfError | mfOKButton );
}

typedef char *_charPtr;
typedef TPoint *PPoint;

#pragma warn -rvl

ushort doEditDialog( int dialog, ... ) { //ࠡ稪 訡
 va_list arg;
 char buf[80];
 ostrstream os( buf, sizeof( buf ) );
 switch( dialog ) {
  case edOutOfMemory:
   return messageBox( "   믮 樨!",
    mfError | mfOKButton );
  case edReadError: {
   va_start( arg, dialog );
   os << "訡 ⥭ 䠩 " << va_arg( arg, _charPtr ) << "." << ends;
   va_end( arg );
   return messageBox( buf, mfError | mfOKButton );
  }
  case edWriteError: {
   va_start( arg, dialog );
   os << "訡  䠩 " << va_arg( arg,_charPtr ) << "." << ends;
   va_end( arg );
   return messageBox( buf, mfError | mfOKButton );
  }
  case edCreateError: {
   va_start( arg, dialog );
   os << "  ᮧ 䠩 " << va_arg( arg, _charPtr ) << "." << ends;
   va_end( arg );
   return messageBox( buf, mfError | mfOKButton );
  }
  case edSaveModify: {
   va_start( arg, dialog );
   os << va_arg( arg, _charPtr ) << "  ! ࠭?" << ends;
   va_end( arg );
   return messageBox( buf, mfInformation | mfYesNoCancel );
  }
  case edSaveUntitled: return messageBox( "࠭ 䠩 untitled?",
   mfInformation | mfYesNoCancel );
  case edSaveAs: {
   va_start( arg, dialog );
   return execDialog( new TFileDialog( "*.*",
    "࠭ 䠩 ", "~~", fdOKButton, 101 ),
    va_arg( arg, _charPtr ) );
  }
  case edFind: {
   va_start( arg, dialog );
   return execDialog( createFindDialog(), va_arg( arg, _charPtr ) );
  }
  case edSearchFailed:
   return messageBox( "᪮ ⥪  !",
   mfError | mfOKButton );
  case edReplace: {
   va_start( arg, dialog );
   return execDialog( createReplaceDialog(), va_arg( arg, _charPtr ) );
  }
  case edReplacePrompt:
   TRect r( 0, 1, 40, 8 ); //   ஬
   r.move( (TProgram::deskTop->size.x-r.b.x)/2, 0 );
   TPoint t = TProgram::deskTop->makeGlobal( r.b );
   t.y++;
   va_start( arg, dialog );
   TPoint *pt = va_arg( arg, PPoint );
   if( pt->y <= t.y ) r.move( 0, TProgram::deskTop->size.y - r.b.y - 2 );
   va_end( arg );
   return messageBoxRect( r, "  ப?",
    mfYesNoCancel | mfInformation );
  }
}

#pragma warn .rvl
